Attribute VB_Name = "Fichiers"
'==================================================================================
'   Explorateur de disk "Off line"
'   permet de sauvegarder l'arborescence d'un disk
'
'   fred.just@free.fr
'   fredjust@hotmail.com
'   http://fred.just.free.fr/
'
'==================================================================================


Option Explicit

'==================================================================================
'   OUVRE UN FICHIER TEXTE EXISTANT
'   EN ECRITURE PAR DEFAUT
'   PARAMETRES :
'       NOM DU FICHIER AVEC SON CHEMIN
'       TEXTSTREAM DANS LEQUEL SERA PLACER LE CONTENU DU FICHIER
'   PARAMETRES OPTIONELS :
'       LECTURESEUL SI TRUE ECRITURE IMPOSIBLE
'       POURAJOUR  SI TRUE SE PLACE A LA FIN
'   RETOURNE 0 SI TOUT C EST BIEN PASSER LE NUMERO DE L ERR SINON
'==================================================================================
Public Function OuvreFichierTexte(ByVal NomFichier As String, ByRef TextStream, _
                        Optional ByVal LectureSeul As Boolean, _
                        Optional ByVal PourAjout As Boolean) As Long
Dim FileSystemObject, LeFile

On Error GoTo gestion_erreur

    Set FileSystemObject = CreateObject("Scripting.FileSystemObject")
    Set LeFile = FileSystemObject.GetFile(NomFichier)
    If LectureSeul Then
        Set TextStream = LeFile.OpenAsTextStream(1)
    Else
        If PourAjout Then
            Set TextStream = LeFile.OpenAsTextStream(8)
        Else
            Set TextStream = LeFile.OpenAsTextStream(2)
        End If
    End If
    
    OuvreFichierTexte = 0
Exit Function

gestion_erreur:
    OuvreFichierTexte = Err.Number
End Function

'==================================================================================
'   CREER UN FICHIER TEXTE
'   RETOURNE 0 SI TOUT C EST BIEN PASSER LE NUMERO DE L ERR SINON
'==================================================================================
Public Function CreerFichierTexte(ByVal NomFichier As String, ByRef TextStream) As Long

Dim FileSystemObject, LeFile

On Error GoTo gestion_erreur

    Set FileSystemObject = CreateObject("Scripting.FileSystemObject")
    Set TextStream = FileSystemObject.CreateTextFile(NomFichier)
    CreerFichierTexte = 0
    
Exit Function

gestion_erreur:
    CreerFichierTexte = Err.Number
End Function

'==================================================================================
'   FERME LE FICHIER TEXTSTREAM
'   RETOURNE 0 SI TOUT C EST BIEN PASSER LE NUMERO DE L ERR SINON
'==================================================================================
Public Function FermeFichier(ByRef TextStream) As Long
On Error GoTo gestion_erreur

    TextStream.Close
    FermeFichier = 0
    
Exit Function
gestion_erreur:
    FermeFichier = Err.Number
End Function


'==================================================================================
'   AFFICHE LA BOITE D OUVERTURE DE FICHIER
'   RENVOIE LE NOM AINSI QUE LE CHEMIN DU FICHIER CHOISI
'   EN CAS D ANNULATION RENVOIE ""
'   PARAMETRES OPTIONELS :
'       LES FILTRES : *.* PAR DEFAUT, A PASSER AINSI : "TXT HTML BAT"
'       LE NOM DU FICHIER SANS LE CHEMIN
'       LE TITRE DE LA BOITE D OUVERTURE
'       NUMERO DE L ERREUR QUI C EST PRODUIT
'==================================================================================
Public Function OuvrirFichierExistant(Optional ByVal TypeFile As String, _
                                    Optional File As String, _
                                    Optional ByVal DialogTitle As String, _
                                    Optional ErrNumber As Long) As String
Dim tempo As String
Dim Extention As String
Dim BoiteOuverture As CommonDialog

Set BoiteOuverture = Form1.CommonDialog1

On Error GoTo ErrHandler
    BoiteOuverture.Flags = cdlOFNHideReadOnly
    BoiteOuverture.Filter = ""
    
    If DialogTitle <> "" Then BoiteOuverture.DialogTitle = DialogTitle
    
    If TypeFile = "" Then
        BoiteOuverture.Filter = "Tous les fichiers (*.*)|*.*"
    Else
        If InStr(1, TypeFile, " ", vbTextCompare) = 0 Then
            BoiteOuverture.Filter = "Fichiers " + UCase(TypeFile) + "|*." + UCase(TypeFile)
        Else
            tempo = UCase(TypeFile)
            While InStr(1, tempo, " ", vbTextCompare) <> 0
                Extention = Mid(tempo, 1, InStr(1, tempo, " ", vbTextCompare) - 1)
                BoiteOuverture.Filter = BoiteOuverture.Filter & "|Fichiers " + Extention + "|*." + Extention
                tempo = Replace(tempo, Extention + " ", "", , 1)
            Wend
            BoiteOuverture.Filter = BoiteOuverture.Filter & "|Fichiers " + tempo + "|*." + tempo
            BoiteOuverture.Filter = Mid(BoiteOuverture.Filter, 2)
        End If
    End If
    
    BoiteOuverture.FilterIndex = 1
    BoiteOuverture.ShowOpen
    OuvrirFichierExistant = BoiteOuverture.FileName
    File = BoiteOuverture.FileTitle
    ErrNumber = 0
    Exit Function
ErrHandler:
    OuvrirFichierExistant = ""
    ErrNumber = Err.Number
End Function

'==================================================================================
'   AFFICHE LA BOITE DE SAUVEGARDE D UN FICHIER
'   RENVOIE LE NOM AINSI QUE LE CHEMIN DU FICHIER CIBLE
'   EN CAS D ANNULATION RENVOIE ""
'   PARAMETRES OPTIONELS :
'       LES FILTRES : *.* PAR DEFAUT, A PASSER AINSI : "TXT HTML BAT"
'       LE NOM DU FICHIER SANS LE CHEMIN
'       LE TITRE DE LA BOITE DE SAUVEGARDE
'       NUMERO DE L ERREUR QUI C EST PRODUIT
'==================================================================================
Public Function EnregistrerSous(Optional ByVal TypeFile As String, _
                            Optional File As String, _
                            Optional ByVal DialogTitle As String, _
                            Optional ErrNumber As Long) As String
Dim tempo As String
Dim Extention As String
Dim BoiteOuverture As CommonDialog

Set BoiteOuverture = Form1.CommonDialog1

On Error GoTo ErrHandler
    BoiteOuverture.Flags = cdlOFNHideReadOnly
    BoiteOuverture.Filter = ""
    
    If DialogTitle <> "" Then BoiteOuverture.DialogTitle = DialogTitle
    If TypeFile = "" Then
        BoiteOuverture.Filter = "Tous les fichiers (*.*)|*.*"
    Else
        If InStr(1, TypeFile, " ", vbTextCompare) = 0 Then
            BoiteOuverture.Filter = "Fichiers " + UCase(TypeFile) + "|*." + UCase(TypeFile)
        Else
            tempo = UCase(TypeFile)
            While InStr(1, tempo, " ", vbTextCompare) <> 0
                Extention = Mid(tempo, 1, InStr(1, tempo, " ", vbTextCompare) - 1)
                BoiteOuverture.Filter = BoiteOuverture.Filter & "|Fichiers " + Extention + "|*." + Extention
                tempo = Replace(tempo, Extention + " ", "", , 1)
            Wend
            BoiteOuverture.Filter = BoiteOuverture.Filter & "|Fichiers " + tempo + "|*." + tempo
            BoiteOuverture.Filter = Mid(BoiteOuverture.Filter, 2)
        End If
    End If
    
    BoiteOuverture.FilterIndex = 1
    BoiteOuverture.ShowSave
    EnregistrerSous = BoiteOuverture.FileName
    File = BoiteOuverture.FileTitle
    ErrNumber = 0
    Exit Function
ErrHandler:
    EnregistrerSous = ""
    ErrNumber = Err.Number
End Function

